function tx_coded = map_4dcoded(coded,framesize)
% function tx_coded = map_4dcoded(coded,framesize)
% Brett McClellan, Solarflare Communications
% map the LDPC coded bits into the 1D cosets on 4 pairs
% inputs: coded- vector of individual coded bits (must be multiple of 8)
%         framesize- number of symbols in the frame that contain coded bits.
% output: tx_coded- vector of size (framesize,4) containing the 4-level cosets


coded_8 = reshape(coded,8,framesize);

lut = [1 3 7 5];

coded_a =[2 1 0 0 0 0 0 0]*coded_8; 
coded_b =[0 0 2 1 0 0 0 0]*coded_8; 
coded_c =[0 0 0 0 2 1 0 0]*coded_8; 
coded_d =[0 0 0 0 0 0 2 1]*coded_8; 

tx_coded(1,1:framesize) = lut(coded_a+1);
tx_coded(2,1:framesize) = lut(coded_b+1);
tx_coded(3,1:framesize) = lut(coded_c+1);
tx_coded(4,1:framesize) = lut(coded_d+1);
tx_coded=tx_coded'-4;

