
% Test mapping and demapping of randomly distributed 12D partitions
% Brett McClellan, Solarflare Communications 10/5/04
% bmcclellan@solarflare.com


N=1e4;

clear TA_12d TB_12d TC_12d TD_12d
clear rx_data0 rx_data1 rx_data2 rx_data3

clear w x1 x2 y1 y2 z1 z2
clear r_w r_x1 r_x2 r_y1 r_y2 r_z1 r_z2


% unif dist 1-bit tx data
w = floor(rand(1,N)*2^1);

% unif dist 3-bit tx data
x1 = floor(rand(1,N)*8);
x2 = floor(rand(1,N)*8);
y1 = floor(rand(1,N)*8);
y2 = floor(rand(1,N)*8);
z1 = floor(rand(1,N)*8);
z2 = floor(rand(1,N)*8);


for ii=1:N
    [TA_12d(ii,1:3),TB_12d(ii,1:3),TC_12d(ii,1:3),TD_12d(ii,1:3)] = map_12dpam12_partition_mex(w(ii),x1(ii),x2(ii),y1(ii),y2(ii),z1(ii),z2(ii));
    [r_w(ii),r_x1(ii),r_x2(ii),r_y1(ii),r_y2(ii),r_z1(ii),r_z2(ii)] = demap_12dpam12_partition_mex(TA_12d(ii,1:3),TB_12d(ii,1:3),TC_12d(ii,1:3),TD_12d(ii,1:3));

    if ( find(r_w(ii) ~= w(ii))>0 |  find(r_x1(ii) ~= x1(ii)) >0 | find(r_x2(ii) ~= x2(ii)) >0 | find(r_y1(ii) ~= y1(ii)) | find(r_y2(ii) ~= y2(ii)) | find(r_z1(ii) ~= z1(ii)) | find(r_z2(ii) ~= z2(ii)) )
        disp(sprintf('ERROR: tx data is %d %d %d %d %d %d %d  rx data is %d %d %d %d %d %d %d',w(ii),x1(ii),x2(ii),y1(ii),y2(ii),z1(ii),z2(ii),r_w(ii),r_x1(ii),r_x2(ii),r_y1(ii),r_y2(ii),r_z1(ii)),r_z2(ii) );
        pause;
    end

end

